﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Example1
{
    class Matrix
    {
        protected int Size;
        protected float[,] Arr;
        public Matrix(int size)
        {
            Arr = new float[size, size];
            Size = size;
        }
        public int GetSize()
        {
            return Size;
        }
        public void Generate(int min, int max)
        {
            Random rnd = new Random();
            for (int i = 0; i < Size; i++)
                for(int j = 0; j < Size; j++)
                    Arr[i,j] = min + rnd.Next((max - min)*100 + 1) / 100;
        }
        public Matrix Multiple1(Matrix matr)
        {
            Matrix newMatr = new Matrix(Size); 
            for (int i = 0; i < Size; i++)
                for (int j = 0; j < Size; j++)                
                    for (int k = 0; k < Size; k++)                    
                        newMatr.Arr[i, j] += Arr[i, k] * matr.Arr[k, j];
                    
                
            return newMatr;
        }
        public Matrix MultipleN(Matrix matr)
        {
            Matrix newMatr = new Matrix(Size);
            Parallel.For(0, Size, delegate(int i)
            {
                    for (int j = 0; j < Size; j++)
                        for (int k = 0; k < Size; k++)
                        newMatr.Arr[i, j] += Arr[i, k] * matr.Arr[k, j];
            });
            return newMatr;
        }

    }
}
